#!/usr/local/bin/perl
# Show a list of firewalled services

require './simple-firewall-lib.pl';
&ui_print_header(undef, $text{'index_title'}, "", undef, 1, 1);

# Make sure firewall works!
$err = &check_firewall();
if ($err) {
	&ui_print_endpage(&text('index_check', $err));
	}

# Show table of services
@servs = &list_services();
if (@servs) {
	print &ui_columns_start([ $text{'index_serv'},
				  $text{'index_proto'},
				  $text{'index_action'},
				  $text{'index_hosts'},
				  $text{'index_move'} ],
				"100", 0,
				[ "width=15%", "width=10%", "width=15%", "width=60%", "width=10" ]);
	$i = 0;
	foreach $s (@servs) {
		local $movers;
		if ($i == 0) {
			$movers .= "<img src=images/gap.gif border=0>";
			}
		else {
			$ps = $servs[$i-1];
			$movers .= "<a href='swap.cgi?id1=$s->{'id'}&id2=$ps->{'id'}'><img src=images/up.gif border=0></a>";
			}
		if ($i == @servs-1) {
			$movers .= "<img src=images/gap.gif border=0>";
			}
		else {
			$ns = $servs[$i+1];
			$movers .= "<a href='swap.cgi?id1=$s->{'id'}&id2=$ns->{'id'}'><img src=images/down.gif border=0></a>";
			}

		print &ui_columns_row(
			[ "<a href='edit.cgi?id=$s->{'id'}'>".
			  ($s->{'serv'} || $text{'index_sall'})."</a>",
			  uc($s->{'proto'}),
			  $s->{'allow'} ? $text{'index_allow'}
				       : $text{'index_deny'},
			  $s->{'mode'} == 0 ? $text{'index_all'} :
					      $s->{'hosts'},
			  $movers ]);
		$i++;
		}
	print &ui_columns_end();
	}
else {
	print "<b>$text{'index_noservs'}</b><p>\n";
	}
print "<a href='edit.cgi?new=1'>$text{'index_add'}</a><p>\n";

# Show apply button
print "<hr>\n";
print &ui_buttons_start();
print &ui_buttons_row("apply.cgi",
	      $text{'index_apply'}, $text{'index_applydesc'});
$st = &init::action_status($module_name);
print &ui_buttons_row("bootup.cgi",
	      $text{'index_bootup'}, $text{'index_bootupdesc'},
	      undef,
	      &ui_radio("bootup", $st == 2 ? 1 : 0,
			   [ [ 1, $text{'yes'} ],
			     [ 0, $text{'no'} ] ]));
print &ui_buttons_end();

&ui_print_footer("/", $text{'index'});

