# Functions for simple firewall management
# XXX ipf support!

do '../web-lib.pl';
&init_config();
do '../ui-lib.pl';
do "$config{'mode'}-lib.pl";
&foreign_require("init", "init-lib.pl");
&foreign_require("cron", "cron-lib.pl");

$services_dir = "$module_config_directory/services";

# list_services()
# Returns a list of services, each of which has number of ports and allowed
# or denied IPs
sub list_services
{
local @rv;
opendir(DIR, $services_dir);
foreach $s (readdir(DIR)) {
	if ($s ne "." && $s ne "..") {
		push(@rv, &get_service($s));
		}
	}
closedir(DIR);
return sort { $a->{'order'} <=> $b->{'order'} } @rv;
}

# get_service(id)
sub get_service
{
local %serv;
&read_file("$services_dir/$_[0]", \%serv);
$serv{'id'} = $_[0];
return \%serv;
}

# save_service(&serv)
sub save_service
{
mkdir($services_dir, 0755) if (!-d $services_dir);
$_[0]->{'id'} ||= time().$$;
$_[0]->{'order'} ||= time();
&write_file("$services_dir/$_[0]->{'id'}", $_[0]);
}

# delete_service(&serv)
sub delete_service
{
unlink("$services_dir/$_[0]->{'id'}");
}

sub check_ethernet
{
return $_[0] =~ /^([0-9a-z]{2}:){5}[[0-9a-z]{2}$/i;
}

1;

